<template>
	<div class="layer-control bg-white flex-col" style="display: flex">
		<div class="bg-white rounded flex-0">
			<div class="header flex-items-center pb-1.5" style="border-bottom: 1px solid black">
				<div class="flex-items-center">
					<span class="ywifont ywicon-guanbi cursor-pointer mr-1.5" @click="closeClick"></span>
					<span class="text-lg font-bold">主题</span>
				</div>
			</div>
		</div>
		<div class="flex-auto content rounded-lg overflow-y-auto">
			<!-- <el-tree
				class="w-full"
				:data="themeInfo"
				:props="defaultProps"
				show-checkbox
				node-key="id"
				default-expand-all
				ref="checkTreeRef"
				@check="handleCheck"
				@node-click="handleNodeClick"
			>
				<template #default="{ node, data }">
					<span>{{ node.label }}</span>
				</template>
			</el-tree> -->
			<div>
				<div class="theme-item" v-for="themeGroup in themeInfo" :key="themeGroup.id">
					<div class="theme-item-title h-fit flex-items-center gap-2 mb-1 justify-between">
						<div class="flex-items-center gap-2">
							<div class="w-1 h-4 bg-[#1677ff]"></div>
							<span class="font-bold">{{ themeGroup.title }}</span>
						</div>
						<!-- <div class="flex-items-center gap-2 mr-1">
							<el-button size="small" @click="cancelTheme(themeGroup.id)">取消</el-button>
						</div> -->
					</div>
					<div>
						<el-radio-group v-model="themeGroup.activeTheme" class="w-full" @change="(val) => handleThemeChange(val, themeGroup)">
							<div class="flex w-full" v-for="(children, index) in themeGroup.viewChildren" :key="index">
								<el-radio v-for="item in children" :key="item.id" :label="item.id" class="flex-1">{{ item.title }}</el-radio>
							</div>
						</el-radio-group>
					</div>
				</div>
			</div>
			<!-- <el-checkbox-group v-model="checkList" :max="1">
				<el-checkbox label="Option A" value="Value A" />
				<el-checkbox label="Option B" value="Value B" />
				<el-checkbox label="Option C" value="Value C" />
				<el-checkbox label="disabled" value="Value disabled" disabled />
				<el-checkbox label="selected and disabled" value="Value selected and disabled" disabled />
			</el-checkbox-group> -->
			<div class="theme-item" v-for="legend in legendList" :key="legend.title">
				<div class="theme-item-title h-fit flex-items-center gap-2 mb-2">
					<div class="w-1 h-4 bg-[#1677ff]"></div>
					<span class="font-bold">{{ legend.title }}</span>
				</div>
				<div class="theme-item-content">
					<el-row :gutter="0">
						<el-col v-for="item in legend.legend" :key="item.style" :span="12" class="mb20">
							<div class="flex-items-center gap-2">
								<div class="w-4 h-2 bg-[#1677ff]" :style="{ backgroundColor: `#${item.style}` }"></div>
								<span>{{ item.label }}</span>
							</div>
						</el-col>
					</el-row>
				</div>
			</div>
		</div>
	</div>
</template>

<script setup lang="ts" name="ThemeControl">
import type { ElTree } from 'element-plus';
import { chunk } from 'lodash-es';
import type { PropType } from 'vue';
import { computed, ref, watch } from 'vue';
import type { OLMap } from '/@/model/map/OLMap';
import { travelTree } from '/@/utils/util';

const props = defineProps({
	olMap: {
		type: Object as PropType<OLMap>,
		required: true,
	},
});
const emit = defineEmits(['close']);

const closeClick = () => {
	emit('close');
};
const checkTreeRef = ref<InstanceType<typeof ElTree>>();
let isHumanCheckTrigger = false;

const themeInfo = computed(() => {
	const info = (props.olMap as OLMap).themeInfo.value;
	// info.push({
	// 	id: 'group-测试',
	// 	title: '测试',
	// 	type: 'theme-group',
	// 	children: [
	// 		{
	// 			id: 'junction_1',
	// 			title: '测试1',
	// 			type: 'theme',
	// 		},
	// 		{
	// 			id: 'junction_2',
	// 			title: '测试2',
	// 			type: 'theme',
	// 		},
	// 		{
	// 			id: 'junction_3',
	// 			title: '测试3',
	// 			type: 'theme',
	// 		},
	// 		{
	// 			id: 'junction_4',
	// 			title: '测试4',
	// 			type: 'theme',
	// 		},
	// 		{
	// 			id: 'junction_5',
	// 			title: '测试5',
	// 			type: 'theme',
	// 		},
	// 		{
	// 			id: 'junction_6',
	// 			title: '测试6',
	// 			type: 'theme',
	// 		},
	// 	],
	// });

	const result = info.map((item, index) => {
		if (item.children) {
			// index == 0 &&
			// 	item.children.push(
			// 		...[
			// 			{
			// 				id: 'junction_1',
			// 				title: '测试1',
			// 				type: 'theme',
			// 			},
			// 			{
			// 				id: 'junction_2',
			// 				title: '测试2',
			// 				type: 'theme',
			// 			},
			// 			{
			// 				id: 'junction_3',
			// 				title: '测试3',
			// 				type: 'theme',
			// 			},
			// 			{
			// 				id: 'junction_4',
			// 				title: '测试4',
			// 				type: 'theme',
			// 			},
			// 			{
			// 				id: 'junction_5',
			// 				title: '测试5',
			// 				type: 'theme',
			// 			},
			// 			{
			// 				id: 'junction_6',
			// 				title: '测试6',
			// 				type: 'theme',
			// 			},
			// 		]
			// 	);
			item.viewChildren = chunk(item.children, 2);
		}
		return item;
	});

	return result;
});

const legendList = computed(() => {
	return props.olMap.legendList.value;
});

const handleThemeChange = async (val, themeGroup) => {
	props.olMap.changeTheme(val);
};
const cancelTheme = (themeId: string) => {
	themeInfo.value.find((item) => item.id === themeId).activeTheme = null;
};
watch(
	() => themeInfo.value,
	(val) => {
		if (isHumanCheckTrigger) {
			isHumanCheckTrigger = false;
			return;
		}

		const keys = [];
		travelTree(themeInfo.value, (item) => {
			if (item.type === 'theme') {
				if (item.isSet) {
					keys.push(item.id);
				}
			}
		});
		// const keys = layerInfo.value.filter((item) => item.isSet).map((item) => item.id);
		checkTreeRef.value?.setCheckedKeys(keys);
	}
);
</script>
<style scoped lang="scss"></style>
